/********************************************************************
  		MCS-51ƬģI2C(V1.1)
    ļVI2C_C51.C
    ļVI2C_C51.HVI2C_C51.LIB
    ˵ģI2CI2Cĵײ㺯緢ݼ
,Ӧλ,ṩ˼ֱĲܷû
Ӳչ.....  
    ע:ǲʱķSCL,̶Ը߾ƵҪ һ
޸....(1us,ƵҪС12MHZ)
    ʱI2C׼ģʽ,100Kbit/S
********************************************************************/

#include <reg51.h>
#include <intrins.h>

#define  uchar unsigned char 	/*궨*/
#define  uint  unsigned int

#define  _Nop()  _nop_(),_nop_()      //,_nop_(),_nop_()      /*ָ*/
#define  _Nop2()  _Nop(),_Nop()      /*ָ*/
#define  _Nop3()  _Nop(),_Nop(),_Nop()      /*ָ*/
#define  _Nop4()  _Nop(),_Nop(),_Nop(),_Nop(),_Nop(),_Nop(),_Nop(),_Nop()      /*ָ*/
sbit SDA=P1^0;            	/*ģI2Cݴλ*/
sbit SCL=P1^1;            	/*ģI2Cʱӿλ*/

bit ack;	         	/*Ӧ־λ*/

/*******************************************************************
                     ߺ               
ԭ: void  Start_I2c();  
:     I2C,I2Cʼ.  
********************************************************************/
void Start_I2c()
{
  SDA=1;   	//ʼź
  _Nop();
  SCL=1;  
  while(~SCL); //ȴӻͷ  ˴û볬ʱֹIIC߳ѭ
  _Nop2(); 
  SDA=0;   	//ʼź
  _Nop4();   // ʼʱ4s  
  SCL=0;   	//ǯסI2Cߣ׼ͻ 
  _Nop2();
}

/*******************************************************************
                       ߺ               
ԭ: void  Stop_I2c();  
:     I2C,I2C.  
********************************************************************/
void Stop_I2c()
{
  SDA=0;  	//ͽź
  _Nop();   	//ͽʱź
  SCL=1;  	//ʱ4s
  while(~SCL); //ȴӻͷ  ˴û볬ʱֹIIC߳ѭ
  _Nop2();
  SDA=1;  	//I2C߽ź
  _Nop4();
}

/*******************************************************************
                 ֽݷͺ               
ԭ: void  SendByte(uchar c);
:     cͳȥ,ǵַ,Ҳ,ȴӦ,
          ״̬λв.(ӦӦʹack=0)     
     	  ack=1; ack=0ʾӦ𻵡
********************************************************************/
void  SendByte(uchar buf)
{	 
    SDA =  buf & 0x80;	  //ֽλ bit7
	_Nop();
    SCL=1;               //ʱΪߣ֪ͨʼλ
	_Nop();
	while(~SCL);         //ȴӻͷ  ˴û볬ʱֹIIC߳ѭ
	_Nop();	        
    SCL=0; 
	_Nop();             

    SDA =  buf & 0x40;	   //ֽλ bit6
	_Nop();
    SCL=1;    
	_Nop();                
	while(~SCL);        
	_Nop();   
    SCL=0; 
	_Nop();             
    
	SDA =  buf & 0x20;	 //ֽλ bit5
	_Nop();
    SCL=1;   
	_Nop();                 
	while(~SCL); 
	_Nop();      
    SCL=0; 
	_Nop();             

	SDA =  buf & 0x10;		//ֽλ bit4
	_Nop();
    SCL=1;  
	_Nop();                  
	while(~SCL);  
	_Nop();     
    SCL=0; 
	_Nop();             

	SDA =  buf & 0x08;	   //ֽλ bit3
	_Nop();
    SCL=1;   
	_Nop();                 
	while(~SCL);   
	_Nop();    
    SCL=0; 
	_Nop();             

	SDA =  buf & 0x04;		//ֽλ bit2
	_Nop();
    SCL=1;  
	_Nop();             	     
	while(~SCL);  
	_Nop();    
    SCL=0; 
	_Nop();             

	SDA =  buf & 0x02;		//ֽλ bit1
	_Nop();
    SCL=1;  
	_Nop();                 
	while(~SCL);  
	_Nop();     
    SCL=0; 
	_Nop();           
	
	SDA =  buf & 0x01;		//ֽλ bit0
	_Nop();
    SCL=1;  
	_Nop();                 
	while(~SCL); 
	_Nop();      
    SCL=0; 
	_Nop();              	   

    _Nop3();
	SDA=1;               //8λͷߣ׼Ӧλ
    _Nop();
    SCL=1;  
	while(~SCL);     //ȴӻͷ  ˴û볬ʱֹIIC߳ѭ  
  	if(SDA==1)
	   ack=0;     
    else 
	   ack=1;        //жǷյӦź
    SCL=0;
    _Nop();
}

/*******************************************************************
                 ֽݽպ               
ԭ: uchar  RcvByte();
:  	  մ,жߴ(Ӧź)
          ӦӦӻ  
********************************************************************/	
uchar  RcvByte()
{
    uchar retc = 0;	 
    retc=0; 
    SDA=1;             		//Ϊ뷽ʽ
    
    SCL=0;                  //ʱΪͣ׼λ               
    _Nop4();                    
    SCL=1;                  //ʱΪʹЧ
	while(~SCL);            //ȴӻͷ  ˴û볬ʱֹIIC߳ѭ
    if(SDA==1)
	{
	   retc = retc | 0x80;  //λ,յλretc 
	}
	else
	{
	   _Nop2(); 
	}

    SCL=0;
	_Nop4();                    
    SCL=1;                  //ʱΪʹЧ
	while(~SCL);            //ȴӻͷ  ˴û볬ʱֹIIC߳ѭ 
    if(SDA==1)
	{
	   retc = retc | 0x40;  //λ,յλretc 
	}
	else
	{
	   _Nop2(); 
	}

	SCL=0;
	_Nop4();                    
    SCL=1;                  //ʱΪʹЧ
	while(~SCL);            //ȴӻͷ  ˴û볬ʱֹIIC߳ѭ
    if(SDA==1)
	{
	   retc = retc | 0x20;  //λ,յλretc 
	}
	else
	{
	   _Nop2(); 
	}

	SCL=0;
	_Nop4();                    
    SCL=1;                  //ʱΪʹЧ
	while(~SCL);            //ȴӻͷ  ˴û볬ʱֹIIC߳ѭ
    if(SDA==1)
	{
	   retc = retc | 0x10;  //λ,յλretc 
	}
	else
	{
	   _Nop2(); 
	}

	SCL=0;
	_Nop4();                    
    SCL=1;                  //ʱΪʹЧ
	while(~SCL);            //ȴӻͷ  ˴û볬ʱֹIIC߳ѭ
    if(SDA==1)
	{
	   retc = retc | 0x08;  //λ,յλretc 
	}
	else
	{
	   _Nop2(); 
	}

	SCL=0;
	_Nop4();                    
    SCL=1;                  //ʱΪʹЧ
	while(~SCL);            //ȴӻͷ  ˴û볬ʱֹIIC߳ѭ
    if(SDA==1)
	{
	   retc = retc | 0x04;  //λ,յλretc 
	}
	else
	{
	   _Nop2(); 
	}

	SCL=0;
	_Nop4();                    
    SCL=1;                  //ʱΪʹЧ
	while(~SCL);            //ȴӻͷ  ˴û볬ʱֹIIC߳ѭ
    if(SDA==1)
	{
	   retc = retc | 0x02;  //λ,յλretc 
	}
	else
	{
	   _Nop2(); 
	}

	SCL=0;
	_Nop4();                    
    SCL=1;                  //ʱΪʹЧ
	while(~SCL);            //ȴӻͷ  ˴û볬ʱֹIIC߳ѭ
    if(SDA==1)
	{
	   retc = retc | 0x01;  //λ,յλretc 
	}
	else
	{
	   _Nop2(); 
	}

	SCL=0;
    return(retc);
}  
/********************************************************************
                     ӦӺ
ԭ:  void Ack_I2c(bit a);
:      Ӧź(ӦӦźţλa)
********************************************************************/
void Ack_I2c(bit a)
{
  	SCL=0;
    if(a==0)SDA=0;     	     /*ڴ˷ӦӦź */
    else SDA=1;
    _Nop();
    _Nop();
    _Nop();      
    SCL=1;
    _Nop();
    while(~SCL); //ȴӻͷ  ˴û볬ʱֹIIC߳ѭ
    _Nop();                    /*ʱӵ͵ƽڴ4s*/
    _Nop();
    _Nop();
    _Nop();  
    SCL=0;                     /*ʱߣǯסI2CԱ*/
    _Nop();
    _Nop();    
}



/*******************************************************************
                 ûӿں                                   
*******************************************************************/


/*******************************************************************
                 ӵַֽݺ               
ԭ: bit  ISendByte(uchar sla,uchar c);  
:     ߵ͵ַݣߵȫ,ַsla.
          1ʾɹ
ע⣺    ʹǰѽߡ
********************************************************************/
bit ISendByte(uchar sla,uchar c)
{
   Start_I2c();               /**/
   SendByte(sla);             /*ַ*/
   if(ack==0)return(0);
   SendByte(c);               /**/
   if(ack==0)return(0);
   Stop_I2c();                /**/ 
   return(1);
}




/*******************************************************************
                    ӵַͶֽݺ               
ԭ: bit  ISendStr(uchar sla,uchar suba,uchar *s,uchar no);  
:     ߵ͵ַӵַ,ݣߵȫ,
          ַslaӵַsubasָݣnoֽڡ
          1ʾɹ
ע⣺    ʹǰѽߡ
********************************************************************/
bit ISendStr(uchar sla,uchar suba,uchar *s,uchar no)
{
   uchar i;

   Start_I2c();               /**/
   SendByte(sla);             /*ַ*/
   if(ack==0)return(0);
   SendByte(suba);            /*ӵַ*/
   if(ack==0)return(0);

   for(i=0;i<no;i++)
   {   
     SendByte(*s);            /**/
     if(ack==0)return(0);
     s++;
   } 
   Stop_I2c();                /**/ 
   return(1);
}


/*******************************************************************
                    ӵַͶֽݺ               
ԭ: bit  ISendStrExt(uchar sla,uchar *s,uchar no);  
:     ߵ͵ַӵַ,ݣߵȫ,
          ַslasָݣnoֽڡ
          1ʾɹ
ע⣺    ʹǰѽߡ
********************************************************************/
bit ISendStrExt(uchar sla,uchar *s,uchar no)
{
   uchar i,j;
	 j=250;                 // 250*( 4.7uS+2.5us*8)=6ms //400KʣûӦ6msʱ˳
   while(j)
	 {	 
     Start_I2c();               /**/
     SendByte(sla);             /*ַ*/
     if(ack==1)break;             //ģӦɹ˳ѭ׼
		if( j--==0){  Stop_I2c(); return(0);      }
	 }
   for(j=4;j>0;j--);
   for(i=0;i<no;i++)
   {   
     SendByte(*s);            /**/
     if(ack==0)
	     return(0);
     s++;
	 for(j=4;j>0;j--);
   } 
   Stop_I2c();                /**/ 
   return(1);
}





/*******************************************************************
                    ӵַֽݺ               
ԭ: bit  IRcvByte(uchar sla,ucahr *c);  
:     ߵ͵ַݣߵȫ,
          ַslaֵc.
           1ʾɹ
ע⣺    ʹǰѽߡ
********************************************************************/
bit IRcvByte(uchar sla,uchar *c)
{
   Start_I2c();                /**/
   SendByte(sla+1);            /*ַ*/
   if(ack==0)return(0);
   *c=RcvByte();               /*ȡ*/
   Ack_I2c(1);                 /*ͷǾʹλ*/
   Stop_I2c();                 /**/ 
   return(1);
}



/*******************************************************************
                    ӵַȡֽݺ               
ԭ: bit  ISendStr(uchar sla,uchar suba,uchar *s,uchar no);  
:     ߵ͵ַӵַ,ݣߵȫ,
          ַslaӵַsubaݷsָĴ洢noֽڡ
           1ʾɹ
ע⣺    ʹǰѽߡ
********************************************************************/
bit IRcvStr(uchar sla,uchar suba,uchar *s,uchar no)
{
   uchar i;

   Start_I2c();                  /**/
   SendByte(sla);                /*ַ*/
   if(ack==0)return(0);
   SendByte(suba);               /*ӵַ*/
   if(ack==0)return(0);

   Start_I2c();			 /**/
   SendByte(sla+1);
   if(ack==0)return(0);
   for(i=0;i<no-1;i++)
   {   
      *s=RcvByte();               /**/
      Ack_I2c(0);                /*;ʹλ*/  
      s++;
   } 
   *s=RcvByte();
   Ack_I2c(1);                   /*ͷӦλ*/
   Stop_I2c();                   /**/ 
   return(1);
}


/*******************************************************************
                    ӵַȡֽݺ               
ԭ: bit  ISendStrExt(uchar sla,uchar *s,uchar no);  
:     ߵ͵ַ,,ߵȫ.
          ַslaݷsָĴ洢
          noֽڡ1ʾɹ
ע⣺    ʹǰѽߡ
********************************************************************/
bit IRcvStrExt(uchar sla,uchar *s,uchar no)
{
   uchar i;

   Start_I2c();
   SendByte(sla+1);
   if(ack==0)return(0);

   for(i=0;i<no-1;i++)
   {   
      *s=RcvByte();               /**/
      Ack_I2c(0);                 /*;ʹλ*/  
      s++;
   } 
   *s=RcvByte();
   Ack_I2c(1);                    /*ͷӦλ*/
   Stop_I2c();                    /**/ 
   return(1);
}

bit TX522_I2C_Rcv(uchar sla,uchar *s)
{
    uchar i,FrameLen;	 
    uchar j;
	
j=250;         // 250*( 4.7uS+2.5us*8)=6ms //400KʣûӦ6msʱ˳
while(1)
{	Start_I2c();
  SendByte(sla+1);  // ӵַ+write
	if(ack==1)
	{
	   break;      //ģӦɹ˳ѭ׼
	}
	if( j--==0){  Stop_I2c(); return(0);      } //ģ鳬ʱûӦ𣬷س
	
}
	FrameLen=RcvByte();  //һֽ(֡ȷҪȡݳ	
	Ack_I2c(0);                 //Ӧλ
	if( (FrameLen<6) || (FrameLen>31) )//С֡6֡ȡԶѰݣ31
	{
	  Stop_I2c();                    //     
		return 0;
	}
	*s =  FrameLen;
	s++;  
	
    for(i=0;i<FrameLen-2;i++)	 //ٶȡ֡2ݣΪ֡䱾Լ1滹һֽڣټ1
    {   
      *s=RcvByte();               //ȡ֡
      Ack_I2c(0);                 //Ӧλ
      s++;
    } 
    *s=RcvByte();
    Ack_I2c(1);                    //ͷӦλ
    Stop_I2c();                    // 
    return(1);
}

//ȡԶѰݣûӦϼINT_outǷпȻִиú
//Ѱģ鱣ݵʱΪ500ms500msûжݣݽ
bit TX522_AutoDetectData_Rcv(uchar *s)
{
    uchar i, FrameLen;	 
	
	Start_I2c();
    SendByte(0xb2+1);  // ӵַ+write
	if(ack==0)		  //Ӧٷһ
	{
	    Start_I2c(); 
        SendByte(0xb2+1);  // ӵַ+write
		if(ack==0)		  //Ӧٷһ
	    {
		    return 0;	
		}
	}	
	FrameLen=RcvByte();  //һֽ(֡ȷҪȡݳ	
	Ack_I2c(0);                 //Ӧλ
	if( (FrameLen<6) || (FrameLen>31) )//С֡6֡ȡԶѰݣ31
	{
	    Stop_I2c();                    //     
		return 0;
	}
	*s =  FrameLen;
	s++;  
	
    for(i=0;i<FrameLen-2;i++)	 //ٶȡ֡2ݣΪ֡䱾Լ1滹һֽڣټ1
    {   
      *s=RcvByte();               //ȡ֡
      Ack_I2c(0);                 //Ӧλ
      s++;
    } 
    *s=RcvByte();
    Ack_I2c(1);                    //ͷӦλ
    Stop_I2c();                    // 
    return(1);
}