NAME	TX522_I2C

SDA	BIT	P1.0	;
SCL	BIT	P1.1	;

?PR?_TX522_I2C_Rcv?TX522_I2C    	SEGMENT CODE 
?DT?_TX522_I2C_Rcv?TX522_I2C    	SEGMENT DATA OVERLAYABLE 
?PR?_TX522_I2C_Send?TX522_I2C   	SEGMENT CODE 
?DT?_TX522_I2C_Send?TX522_I2C   	SEGMENT DATA OVERLAYABLE 

	
	PUBLIC	?_TX522_I2C_Send?BYTE
	PUBLIC	_TX522_I2C_Send
	PUBLIC	?_TX522_I2C_Rcv?BYTE
	PUBLIC	_TX522_I2C_Rcv


	RSEG  ?DT?_TX522_I2C_Rcv?TX522_I2C
?_TX522_I2C_Rcv?BYTE:
    slv_adr?040:   DS   1
    databfr?041:   DS   1

	RSEG  ?DT?_TX522_I2C_Send?TX522_I2C
?_TX522_I2C_Send?BYTE:
    slv_adr?142:   DS   1
    databfr?143:   DS   1
        len?144:   DS   1

; unsigned char TX522_I2C_Rcv(unsigned char slv_adr,unsigned char idata *databfr)

	RSEG  ?PR?_TX522_I2C_Rcv?TX522_I2C
_TX522_I2C_Rcv:
	MOV    	A,R5
        MOV	R0,A
	MOV	R3,#1
	MOV     R2,#200        ;ѭʼźŴ
I2C_START_LOOP:
        LCALL  	START         	;
        MOV    	A,R7
        SETB	ACC.0           ;׼ж 
        LCALL  	WRBYTE
        LCALL  	CACK        
	JNC	I2C_START_OK    ;ǷӦӦ
        MOV     R7,#250
        DJNZ    R7,$
	DJNZ    R2,I2C_START_LOOP         ;ѭ250*0.5=125ms
	JMP     RNACKEXIT
I2C_START_OK:
	CLR	F0		;ݱ־
RD3:	LCALL  	RDBYTE      	;ȶֽ
        MOV    	@R0,A
	DJNZ    R3,SACK
	;JZ	SNACK		;ݳΪ˳
	SETB	F0		;ݱ־λ
	MOV	R3,A
	CJNE	A,#6,RD1	;ݳӦС6
	SJMP	RD2	
RD1:	JC	RD6		;С6,ֹͣλ,ʧ˳
RD2:	CJNE	A,#37,RD4
	SJMP	RD5
RD4:	JNC	RD6		;ݳȴ37,ֹͣλ,ʧ˳
RD5:	DEC	R3		;ȥ֡
	SJMP	SACK
RDN1:   LCALL  	RDBYTE      	;
        MOV    	@R0,A
	DJNZ    R3,SACK
SNACK:  LCALL  	MNACK       	;һֽڷӦλ               
RETRDN: LCALL  	STOP 			;
        MOV	R7,#1		;ɹTRUE
	RET
	LJMP	0000H
SACK:   LCALL  	MACK
        INC     R0
	JNB	F0,RD3
        SJMP   	RDN1
	LJMP	0000H
RD6:	LCALL  	STOP 	
RNACKEXIT:
	MOV	R7,#0		;ʧܷFALSE
	RET
	LJMP	0000H
	
; END OF _TX522_I2C_Rcv

; unsigned char TX522_I2C_Send(unsigned char slv_adr,unsigned char *databfr,unsigned char len);

	RSEG  ?PR?_TX522_I2C_Send?TX522_I2C
_TX522_I2C_Send:
	MOV	A,R5
	MOV  	R0,A
	LCALL  	START        	;
        MOV    	A,R7
	LCALL  	WRBYTE       	;ӵַ      
        LCALL  	CACK
        JC     	WNACKEXIT	 ;Ӧ˳
WRDA:   MOV    	A,@R0
        LCALL  	WRBYTE       	;ʼд
        LCALL  	CACK
	JC	WNACKEXIT
        INC     R0
        DJNZ    R3,WRDA      	;ждû
RETWRN: LCALL  	STOP
	MOV	R7,#1		;ɹTRUE
        RET
	LJMP	0000H
WNACKEXIT:
	MOV	R7,#0		;ʧܷFALSE
	RET
	LJMP	0000H

; END OF _TX522_I2C_Send
Dley_5us:
         nop
	 nop
	 nop
	 nop
	 ret



START:    SETB  SDA
          NOP
          SETB  SCL     			 ;ʼʱ4.7us
          JNB	SCL,$	  
          CLR  SDA      
          NOP
          CLR   SCL     		 	;ǯסߣ׼
          NOP
          RET
	  LJMP	0000H

;ӳ
STOP:     CLR    SDA
          NOP
          SETB   SCL    			;ͽʱź
          JNB	SCL,$
          SETB  SDA    			;
          NOP          			;֤һֹźźʼźŵĿʱ4.7us
          RET
	  LJMP	0000H

;Ӧźӳ
MACK:     CLR  	SDA      		;SDA0 
          NOP
          SETB 	SCL
          JNB	SCL,$            			;ʱ䣬SCLΪʱ4.7us
          CLR  	SCL
          NOP
          RET
	  LJMP	0000H

;ͷӦź
MNACK:  SETB 	SDA          	;SDA1 
          NOP
          SETB 	SCL
          JNB	SCL,$               		;ʱ䣬SCLΪʱ4.7us
         ; NOP
          CLR  SCL
          RET
	  LJMP	0000H

; Ӧλӳ
; ӦλC
CACK:	SETB  	SDA
        NOP
        SETB  	SCL
        JNB	SCL,$
	MOV  	C,SDA
;	NOP
        CLR  	SCL
        NOP
        RET
	LJMP	0000H

;ֽӳ
;ֽݷACC       
;ÿһֽҪһCACKӳȡӦλ            
WRBYTE: MOV  	R2,#08H
 	RLC   	A
WLP:	MOV	SDA,C
	SETB	SCL
	JNB	SCL,$
	RLC   	A
	CLR	SCL
	DJNZ	R2,WLP
     	RET
	LJMP	0000H
        
;ȡֽӳ                    
;ֵACC
;ÿȡһֽҪһӦ/Ӧź 
RDBYTE: MOV  	R2,#08H
	SETB  	SDA
;	DB	0,0,0,0,0,0,0,0
;	DB	0,0,0,0	;,0,0,0,0
RLP:    
        SETB  	SCL         		 ;ʱΪߣλ
	JNB	SCL,$
        MOV  	C,SDA        		 ;ȡλ
	RLC	A
        CLR   	SCL          		 ;SCLͣʱ4.7us
        DJNZ  	R2,RLP        		 ;δ8λһ
        RET
	LJMP	0000H

	END


