/****************************************Copyright (c)**************************************************
**                                      TXRFID
**                                    
**                                 http://www.txrfid.com
**
**--------------ļϢ-------------------------------------------------------------------------
**      : TX_D.H    
**      : TXRFID
**    : 200815
**        : TX500DCļ
**
**---------------------------------------------------------------------------------------
**-----------------޸ļ¼--------------------------------------------------------------
** ޸:    1.

** ǰ汾:    v1.0 
**   :    TXRFID
** ޸:    20090205
** ע    : 
**---------------------------------------------------------------------------------------
**
**-----------------------------------------------------------------------------------------
****************************************************************************************/
#ifndef __TX_D_H__                    // ֹͷļظ                                                          
#define __TX_D_H__

#ifdef TX_D_GLOBALS                   // עTX_D.c ļжTX_GLOBALS
	#define TX_EXT
#else
	#define TX_EXT extern
#endif


#include "typeDef.h"


/****************************************************************************/
/**                                                                        **/
/**                     Definitions and Macros                             **/
/****************************************************************************/
//¶ṩԤʹܣʹĳʱ뽫ʹΪ1Ϊ0


#define TX_Get_Info_en             1
#define TX_Config_en               1
#define TX_ConfigAnt_en			   1

#define TX_Load_Key_en             1   

#define TX_Close_en                0
#define TX_Clr_Control_Bit_en      1
#define TX_Set_Control_Bit_en      1
#define TX_Buzzer_en               1

#define TX_Get_CardSnr_en          1
#define TX_Write_Auth_en           1
#define TX_Ul_Write_en             1
#define TX_Read_Auth_en            1
#define TX_WriteValue_Auth_en      1
#define TX_Value_Auth_en           1
#define TX_ReadValue_Auth_en       1 

#define TX_Halt_en                 1
#define TX_Reset_en                0

#define TX_AutoDetect_en		   1
#define TX_ReadADDT_en			   1

#define TX_Request_en              1
#define TX_Casc_Anticoll_en        1
#define TX_Casc_Select_en          1
#define TX_Auth2_en                1    
#define TX_Auth_Key_en             1

#define TX_Read_en                 1
#define TX_Write_en                1
#define TX_Value_en                0

//===================================  ================================
//================================== ԶѰ =========================
#define ADCONTINUE              0x04            // ֮
#define ADHALT                  0x08            // 󽫿

#define ADRFU                   0x00            // ȡȡԶ
#define ADREENABLE              0x01            // ȡԶ


// Ƭ
/* #define MF1_S50                 0               
#define MF1_S70                 1
#define MF0_ULIGHT              2
#define MF1_LIGHT               3 */
#define MF1_S50                 0x04               
#define MF1_S70                 0x02
#define MF0_ULIGHT              0x44
#define MF1_LIGHT               0x10 

// PICC 
#define IDLE                    0x26
#define ALL                     0x52
#define ANTICOLL1               0x93       // anticollision level 1
#define ANTICOLL2               0x95       // anticollision level 2
#define ANTICOLL3               0x97       // anticollision level 3 
#define KEYA                    0x60       //ܳA
#define KEYB                    0x61       //ܳB
#define DECREMENT               0xC0
#define INCREMENT               0xC1
#define RESTORE                 0xC2

//ͨ֡
#define ETX                     0x03       //ֹ
//崮ݻַԪֵ
#define FRAMELEN	0		//֡
#define CMDTYPE		1		//
#define COMMAND		2		//
#define STATUS		2		//Ӧ״̬
#define LENGTH      3		//ݳ
#define DATA        4		//ʼλ
#define PRTCLEN		6		//Эַ

#define FALSE                   0
#define TRUE                    1

//Communication Error
#define COMM_OK                 0x00      //óɹ
#define COMM_ERR                0xff      //ͨŴ
//巵ش
#define SEQERR		2
#define BCCERR		4

//mifare error
#define OK                      0          //óɹ
#define NO_TAG_ERR              (-1)          //Чûп
#define CRC_ERR                 (-2)          //ӿнյ˴CRCУ
#define EMPTY                   (-3)          //ֵ
#define AUTH_ERR                (-4)          //֤
#define PARITY_ERR              (-5)         //ӿнյ˴Уλ
#define CODE_ERR                (-6)          //ͨŴ

#define SERNR_ERR               (-8)          //ڷͻʱ˴Ĵ
#define KEY_ERR                 (-9)          //֤ʵ*****
#define NOT_AUTH_ERR            (-10)         //û֤
#define BIT_COUNT_ERR           (-11)         //ӿнյ˴λ
#define BYTE_COUNT_ERR          (-12)         //ӿн˴ֽ
#define TRANS_ERR               (-14)         //Transfer
#define WRITE_ERR               (-15)         //Write
#define INCR_ERR                (-16)         //Increment
#define DECR_ERR                (-17)         //Decrment
#define READ_ERR                (-18)         //Read
#define COLL_ERR                (-24)         //ͻ
#define ACCESS_TIMEOUT          (-27)         //ʳʱ
#define QUIT                    (-30)         //һʱ

//check write Error
#define CHK_WR_OK               0          //Check Writeȷ
#define CHK_WR_FAILED           (-1)          //Check Write
#define CHK_WR_COMP_ERR         (-2)          //Check Write:дȽϳ

// Configuration for the reader timeout counter 
// Timer 2 (modify OSC_FREQ if another crystal frequency is used)
#define OSC_FREQ                11059200L                       //ϵͳƵ


//Timer2 is serial's watchdog,2ms overlay.
#define RCAP2_2ms               (65536-2*OSC_FREQ/12000L)     //ʹ12clock
#define START_T2(X)             TR2=0; T2LH=X; TF2=0; TR2=1
#define STOP_T2()               TR2=0

// Timer 2
#define RCAP2_50us              65536L - OSC_FREQ/240417L
#define RCAP2_1ms               65536L - OSC_FREQ/12021L
#define RCAP2_10ms              65536L - OSC_FREQ/1200L


/****************************************************************************/
/**                                                                        **/
/**                     Exported Functions                                 **/
/**Աⲿõĺ                                                    **/
/****************************************************************************/
TX_EXT void Serial_Init(void);
 
TX_EXT u8 TX_Load_Key( u8 *KEY);
TX_EXT u8 GetCardNoFromTX66xMode(u8 *Buf);
TX_EXT u8 M1ReadBlockFromTX66xMode(u8 KeyAB,  u8 Block, u8 *RData);
TX_EXT u8 M1WriteBlockFromTX66xMode(u8 KeyAB,  u8 Block, u8 *WrData);

#endif              // __TX_D_H__
